;LEVEL - level.bb;


;Laden eines Levels.
;Starten eines Levels, benutzen eines Levels sowie beenden eines Levels

;spezial Teil Type und Funktionen


;LEVEL - level.bb;

;TEILE;

Type teilinfo
	Field id,typ;ID, Typ
	Field mesh,r#;Mesh Handle, Radius
End Type

Type teil
	Field id,teiid,typ;ID, Teilinfo ID, Typ
	Field mesh,r#
	Field x#,y#,z#
	Field info$
End Type

Global tei.teilinfo,te.teil


Function NeuTeilInfo(typ,r#,mesh$="")
	tei=New teilinfo
		tei\id=Handle(tei)
		tei\typ=typ
		tei\r=r
		
		If mesh<>""
			tei\mesh=LoadMesh(mesh)
			HideEntity tei\mesh
		Else
			tei\mesh=CreatePivot()
		EndIf
	
	Return tei\id
End Function

Function TeilInfoMesh(id)
	tei=Object.teilinfo(id)
	
	Return tei\mesh
End Function

Function TeilInfoNeuMesh(id,mesh)
	tei=Object.teilinfo(id)
		FreeEntity tei\mesh
		tei\mesh=mesh
		HideEntity tei\mesh
End Function

Function NeuTeil(id,x#,y#,z#,info$="")
	tei=Object.teilinfo(id)
	
	te=New teil
		te\id=Handle(te)
		te\teiid=tei\id
		te\typ=tei\typ
		te\info=info
		
		te\mesh=CopyEntity(tei\mesh)
		te\r=tei\r
		
		te\x=x
		te\y=y
		te\z=z
		
		PositionEntity te\mesh,te\x,te\y,te\z
	
	Return te\id	
End Function

Function UpdTeil()
	For te=Each teil
		If EntityDistance(ichobj,te\mesh)=<te\r
			
			Select te\typ
				Case 1;Ende
					leveli$=te\info
					ichbaalt=ichba
					ichbages=ichbages+ichbagestmp
					BeendeLevel
					LadeLevel(leveli)
					ichsx=0
					ichsy=0
				Case 2;+
					ichsx=ichsx*1.25
					ichsy=ichsy*1.25
				Case 3;-
					ichsx=ichsx*0.9
					ichsy=ichsy*0.9
				Case 4;SCHAD
					ichleben=ichleben-1
			End Select			
		EndIf
	Next
End Function

Function KeinTeil()
	For te=Each teil
		FreeEntity te\mesh
		Delete te
	Next
End Function


Global TE_START=NeuTeilInfo(0,1);Start
Global TE_ENDE=NeuTeilInfo(1,1);Ende
Global TE_PLUS=NeuTeilInfo(2,1);+
Global TE_MINUS=NeuTeilInfo(3,1);-
Global TE_SCHAD=NeuTeilInfo(4,1);Schdlich


;TEILE;


;LEVEL;

Global level,leveljetzt$

Function LadeLevel(datei$)
	leveljetzt=datei

	If FileType("level/"+datei)=1	
		stream=ReadFile("level/"+datei)
		
		modus=0
		
		Repeat
			zeile$=ReadLine(stream)
			
			If zeile<>""					
				Select modus
					Case 0;Level
						level=LoadMesh("level/"+zeile)
							EntityType level,2				
					Case 1;Teil
						idstr$=StringBis(zeile," ")
						id=0
						Select idstr
							Case "TE_START"
								id=TE_START
							Case "TE_ENDE"
								id=TE_ENDE
							Case "TE_PLUS"
								id=TE_PLUS
							Case "TE_MINUS"
								id=TE_MINUS
							Case "TE_SCHAD"
								id=TE_SCHAD
						End Select
						
						zeile=StringAb(zeile," ")
						x#=StringBis(zeile," ")
						
						zeile=StringAb(zeile," ")
						y#=StringBis(zeile," ")
						
						zeile=StringAb(zeile," ")
						z#=StringBis(zeile," ")
						
						
						If Trim(zeile)<>""
							zeile=StringAb(zeile," ")
							info$=StringBis(zeile," ")
							
							NeuTeil(id,x,y,z,info)
						EndIf
						
						NeuTeil(id,x,y,z)
						If id=TE_ENDE
							NeuLicht(x,y,-1.01,1,0,255,0,1,1,1)
						EndIf
					Case 2;Hindernis
						name$=StringBis(zeile," ")
						
						zeile=StringAb(zeile," ")
						x#=StringBis(zeile," ")
						
						zeile=StringAb(zeile," ")
						y#=StringBis(zeile," ")
						
						zeile=StringAb(zeile," ")
						z#=StringBis(zeile," ")
						
						zeile=StringAb(zeile," ")
						r#=StringBis(zeile," ")
						
						zeile=StringAb(zeile," ")
						g#=StringBis(zeile," ")
						
						zeile=StringAb(zeile," ")
						b#=StringBis(zeile," ")
						
						zeile=StringAb(zeile," ")
						notbool=StringBis(zeile," ")
						
						zeile=StringAb(zeile," ")
						bool=StringBis(zeile," ")
						
						NeuHindernis(name,x,y,z,r,g,b,notbool,bool)			
					Case 3;Schalter
						hiname$=StringBis(zeile," ")
						hiid=0
						
						For hi=Each hindernis
							If hi\name=hiname
								hiid=hi\id
							EndIf
						Next
						
						zeile=StringAb(zeile," ")
						x#=StringBis(zeile," ")
						
						zeile=StringAb(zeile," ")
						y#=StringBis(zeile," ")
						
						zeile=StringAb(zeile," ")
						z#=StringBis(zeile," ")
						
						
						NeuSchalter(hiid,x,y,z)
					Case 4;Licht
						x#=StringBis(zeile," ")
						
						zeile=StringAb(zeile," ")
						y#=StringBis(zeile," ")
						
						zeile=StringAb(zeile," ")
						z#=StringBis(zeile," ")
						
						zeile=StringAb(zeile," ")
						art=StringBis(zeile," ")
						
						zeile=StringAb(zeile," ")
						r=StringBis(zeile," ")
						
						zeile=StringAb(zeile," ")
						g=StringBis(zeile," ")
						
						zeile=StringAb(zeile," ")
						b=StringBis(zeile," ")
						
						zeile=StringAb(zeile," ")
						a#=StringBis(zeile," ")
						
						zeile=StringAb(zeile," ")
						sx#=StringBis(zeile," ")
						
						zeile=StringAb(zeile," ")
						sy#=StringBis(zeile," ")
						
						
						NeuLicht(x,y,z,art,r,g,b,a,sx,sy)			
					Case 5;Batterie
						x#=StringBis(zeile," ")
						
						zeile=StringAb(zeile," ")
						y#=StringBis(zeile," ")
						
						zeile=StringAb(zeile," ")
						z#=StringBis(zeile," ")
						
						NeuBatterie(x,y,z)
					Case 6;Gegner
						x#=StringBis(zeile," ")
						
						zeile=StringAb(zeile," ")
						y#=StringBis(zeile," ")
						
						zeile=StringAb(zeile," ")
						z#=StringBis(zeile," ")
						
						NeuTurm(x,y,z)
					Case 7;Ende
						Exit
				End Select
			Else
				modus=modus+1
			EndIf
		Until Eof(stream)
		CloseFile(stream)
		
		For te=Each Teil
			If te\typ=0
					EntityType ichobj,0;Temporr!
				PositionEntity ichobj,te\x,te\y,te\z
					EntityType ichobj,1;normal
				Exit
			EndIf
		Next
		
		ichbagestmp=AnzBatterie()
	Else
		SpielEnde(1)
	EndIf
End Function


Function BeendeLevel()
	FreeEntity level
	KeinLicht
	KeinBatterie
	KeinHindernis
	KeinSchalter
	KeinTeil
End Function

Function StringBis$(txt$,char$)
	If Instr(txt,char)<>0
		Return Left(txt,Instr(txt,char)-1)
	Else
		Return txt
	EndIf
End Function

Function StringAb$(txt$,char$)
	If Instr(txt,char)<>0
		Return Right(txt,Len(txt)-Instr(txt,char))
	Else
		Return txt
	EndIf
End Function

;LEVEL;


;LEVEL - level.bb;
