;SCHALTER - schalter.bb;

;Schalter Type und Funktionen
;sowie Wnde und Tren fr Schalter

;SCHALTER - schalter.bb;

Type schalter
	Field id,hiid	;Schalter und Hindernis ID
	Field mesh,surf,brush;Mesh Handle
	Field x#,y#,z#
	Field modus
	Field zeit;Berhrzeit
End Type

Global sc.schalter


Type hindernis
	Field id
	Field name$
	Field mesh
	Field modus,notbool,bool
	Field x#,y#,z#
	Field r,g,b
End Type

Global hi.hindernis

;SCHALTER 3D;

Global schaltertex=LoadAnimTexture("3d/schalter.png",1,256,256,0,2)

Global schaltersurf



;SCHALTER 3D;


;LASERWAND;

Global laserwand=LoadMesh("level/laserwand.b3d")
	EntityType laserwand,2
	EntityFX laserwand,1+4
	EntityBlend laserwand,3
	HideEntity laserwand

Global laserwandtex[2],laserwandtexv#
	laserwandtex[0]=LoadTexture("level/laserwand.png")
	laserwandtex[1]=LoadTexture("level/laserwand1.png")
	laserwandtex[2]=LoadTexture("level/laserwand2.png")

	EntityTexture laserwand,laserwandtex[0],0,0
	EntityTexture laserwand,laserwandtex[1],0,1
	EntityTexture laserwand,laserwandtex[2],0,2



;LASERWAND;


;SCHALTER;

Function NeuSchalter(hiid,x#,y#,z#)
	sc=New schalter
		sc\hiid=hiid
		sc\id=Handle(sc)
		sc\mesh=LoadMesh("3d/schalter.b3d")
			EntityType sc\mesh,2
			EntityFX sc\mesh,4
			HideEntity sc\mesh
			NameEntity sc\mesh,sc\id
			
			PositionEntity sc\mesh,x,y,z
			ShowEntity sc\mesh
			

			For i=1 To CountSurfaces(sc\mesh)
				surf=GetSurface(sc\mesh,i)
				brush=GetSurfaceBrush(surf)
				tex=GetBrushTexture(brush)
				If Right(TextureName(tex),15)="schaltertex.png"
					sc\surf=surf
					sc\brush=brush
					
					BrushFX sc\brush,1
					hi=Object.hindernis(sc\hiid)
					BrushColor sc\brush,hi\r,hi\g,hi\b
					BrushTexture sc\brush,schaltertex,0,0
				EndIf
			Next
			
			PaintSurface sc\surf,sc\brush
End Function

Function UpdSchalter()
	If EntityCollided(ichobj,2)<>0
		For sc=Each schalter
			If sc\id=EntityName(EntityCollided(ichobj,2))
				If sc\zeit=<MilliSecs()
					sc\zeit=MilliSecs()+5000;Wartezeit
					sc\modus=1-sc\modus					
					BrushTexture sc\brush,schaltertex,sc\modus,0
					PaintSurface sc\surf,sc\brush
				EndIf
			EndIf
		Next		
	EndIf
End Function

Function KeinSchalter()
	For sc=Each schalter
		FreeEntity sc\mesh
		Delete sc
	Next
End Function

;SCHALTER;


;HINDERNIS;

Function NeuHindernis(name$,x#,y#,z#,r,g,b,notbool,bool)
	hi=New hindernis
		hi\id=Handle(hi)
		hi\name=name
		hi\bool=bool;AND OR XOR 0 1 2
		hi\notbool=notbool
		hi\mesh=CopyEntity(laserwand)
			PositionEntity hi\mesh,x,y,z
			EntityColor hi\mesh,r,g,b
				hi\r=r
				hi\g=g
				hi\b=b
	Return hi\id
End Function


Function UpdHindernis()
	laserwandtexv=laserwandtexv-0.01
	PositionTexture laserwandtex[0],0,laserwandtexv
	
	For hi=Each hindernis
		schalteranz=0
		schalterwert=0
		ergebnis=0
		
		i=0	
		For sc=Each schalter
			If sc\hiid=hi\id
				schalteranz=schalteranz+1
				schalterwert=schalterwert+sc\modus
			EndIf
		Next
		
		If hi\bool=0;AND
			If schalterwert=schalteranz And schalteranz>0 Then ergebnis=1
		ElseIf hi\bool=1;OR
			If schalterwert>0 And schalteranz>0 Then ergebnis=1
		ElseIf hi\bool=2;XOR
			If schalterwert>0 And schalterwert<schalteranz And schalteranz>0 Then ergebnis=1
		EndIf
		
		If hi\notbool=1;NOT
			ergebnis=Not ergebnis
		EndIf
		
		If hi\modus=0 And ergebnis=1
			hi\modus=1
			HideEntity hi\mesh
		ElseIf hi\modus=1 And ergebnis=0
			hi\modus=0
			ShowEntity hi\mesh
		EndIf
	Next
End Function

Function KeinHindernis()
	For hi=Each hindernis
		FreeEntity hi\mesh
		Delete hi
	Next
End Function

;HINDERNIS;

;SCHALTER - schalter.bb;