SuperStrict

Type TButton
	Global AllButtons:TList = New TList
	Field iX:Int, iY:Int
	Field iRed:Int, iGreen:Int, iBlue:Int
	Field iChecksum:Int
	Field Number:Int
	Field iIsSelected:Int = 0
	Field tiMainImage:timage, tiNumberImage:timage, tiSelectedImage:timage, tiDrawnImage:timage
	
	Method New()
		AllButtons.AddLast(Self)
	End Method
	
	Function Create:TButton(pX:Int, pY:Int, pRed:Int, pGreen:Int, pBlue:Int, pimage1:timage, pimage2:timage, pimage3:timage, number:Int)
		Local B:TButton = New TButton
		B.iX = pX
		B.iY = pY
		
		B.iRed = pRed
		B.iGreen = pGreen
		B.iBlue = pBlue
		B.iChecksum = B.iRed + B.iGreen + B.iBlue
		
		B.tiMainImage = pimage1
		B.tiNumberImage = pimage2
		B.tiSelectedImage = pimage3
		B.tiDrawnImage = B.tiMainImage
		Return B
	End Function
	
	Method Draw()
		SetColor iRed, iGreen, iBlue
		DrawImage(tiDrawnImage, iX, iY)
		SetColor 255, 255, 255
		DrawImage(tiNumberImage, iX, iY)
	End Method
	
	Method SelectThis()
		For Local Button:TButton = EachIn AllButtons
			If Button <> Self Then
				Button.iIsSelected = 0
				Button.tiDrawnImage = Button.tiMainImage
			EndIf
		Next
		tiDrawnImage = tiSelectedImage
		iIsSelected = 1
	End Method
	
	Method Destroy()
		AllButtons.Remove(Self)
	End Method
End Type