
Type TMode
	
	Global GraphX:Int
	Global GraphY:Int
	
	Field ScrollX
	Field ScrollY
	Field Level:TLevel
	Field Panel:TEditPanel
	Field Player:TPlayer
	Field Physics:TPhysics
	
	Field ArrowAnim:Int
	Field ArrowAnimMax:Int
	Field ArrowTimer:Int
	Field ArrowSpeed:Int
	
	Field imgArrowLeft:TImage
	Field imgArrowRight:TImage
	
	
	Method InitValues( lGraphX, lGraphY, lArrowLeft:TImage, lArrowRight:TImage, lArrowAnimMax, lArrowSpeed, lLevel:TLevel, lPhysics:TPhysics, lPlayer:TPlayer, lPanel:TEditPanel )
		
		GraphX = lGraphX
		GraphY = lGraphY
		imgArrowLeft = lArrowLeft
		imgArrowRight = lArrowRight
		ArrowAnimMax = lArrowAnimMax
		ArrowSpeed = lArrowSpeed
		Level = lLevel
		Physics = lPhysics
		Player = lPlayer
		Panel = lPanel
		
	End Method
	
	
	Method UpdatePhysics()
		
		Local Iter:Int = 1
		
		For I = Iter To Level.Plots-1
			
			If Player.X >= Level.XPos[I-Iter] And Player.X < Level.XPos[I] 'And I Mod Iter Then
				Physics.Update( Level.XPos[I-Iter], Level.YPos[I-Iter], Level.XPos[I], Level.YPos[I] )
				Exit
			EndIf
			
		Next
		
	End Method
	
	
	Method Scroll(  lBorderLeft, lBorderRight, lBorderTop, lBorderBottom, lX, lY, lAreaLeft, lAreaRight, lAreaTop = 0, lAreaBottom = 0, lMode = 0, lStrength:Float = 3 )
				
		If lX > lAreaRight Then
			ScrollX :+ (lX-lAreaRight)/lStrength
		EndIf
		If lX < lAreaLeft Then
			ScrollX :- (lAreaLeft-lX)/lStrength
		EndIf
		If ScrollX < lBorderLeft Then ScrollX = lBorderLeft
		If ScrollX > lBorderRight Then ScrollX = lBorderRight
		
	End Method
	
EndType