Graphics3D 640,480,32,2
SetBuffer BackBuffer()
AppTitle "Ballschnipser - Fredko BCC #36 - 1.5"

;LICHT;

Include "include/licht.bb"
Include "include/schalter.bb"
Include "include/batterie.bb"
Include "include/level.bb"
Include "include/smiley.bb"
Include "include/gegner.bb"

;LICHT;



;KOLLISIONEN;

;1 - Spieler
;2 - Level
;3 - Objekte

Collisions 1,2,2,2
Collisions 1,3,1,2
Collisions 3,1,1,2
Collisions 3,2,2,2
Collisions 3,3,2,2

Const GRAV#=0.918
Const WIDER#=0.99

;KOLLISIONEN;


;ICH;

;:D
;:)
;:|
;|:|
;>:|
;>:(
;|:(
;:(

Global ichges$[7]
ichges[0]=":D"
ichges[1]=":)"
ichges[2]=":|"
ichges[3]="|:|"
ichges[4]=">:|"
ichges[5]=">:("
ichges[6]="|:("
ichges[7]=":("

Global ichgesalt=0

Global ichobj=LoadMesh("3d/rollomat.3ds",level)
	EntityFX ichobj,4
	PositionEntity ichobj,-6,3,0
	ScaleEntity ichobj,0.5,0.5,0.5
	
	EntityType ichobj,1
	EntityRadius ichobj,0.5
	
	EntityPickMode ichobj,1

Global ichtex0=CreateTexture(8,8),ichtex1=CreateTexture(64,64)

NeuSmiley(ichobj,"smiley.png",":D",0,127,0,128,255,128,1,ichtex0,ichtex1)

Global ichsx#,ichsy#;Geschwindigkeitsvektor XYZ
Global ichm#=0.01,ichw#=0.5;Masse (kg) Widerstand

Global ichleben=80;Leben
Global ichba,ichbaalt,ichbages,ichbagestmp;Batterienzhler

Global ichkam=CreateCamera(ichobj)
PositionEntity ichkam,0,0,-10

Global mwn#,mwa#,mwd#


Global ichpicke,ichpickm;Pick Entity/Modus


;ICH;


;LEVEL;

LadeLevel("level000.lvl") 

;LEVEL;


;SCHRIFT;

Global schriftgr=LoadFont("fixedsys",64)
Global schriftmt=LoadFont("fixedsys",16)


;SCHRIFT;


;HAUPT;

Global mx,my
Global mh1,md1

Global fps=CreateTimer(59)

;HAUPT;

FlushKeys
Repeat
Cls

UpdHaupt()

UpdateWorld

TranslateEntity ichobj,ichsx,ichsy,0,1
RotateEntity ichkam,0,0,0,1

UpdateWorld

UpdIchObj()

RenderWorld

	If ichpickm=1
		CameraProject ichkam,EntityX(ichpicke),EntityY(ichpicke),EntityZ(ichpicke)
		
		ex#=ProjectedX()
		ey#=ProjectedY()
		dist#=Sqr((mx-ex)*(mx-ex)+(my-ey)*(my-ey))
		win#=(ATan2(mx-ex,my-ey)+450)Mod 360
		
		Color 255,0,0		
		Oval mx-4,my-4,8,8,0
	EndIf
	
	;Text 600,456,ichba+"/"+ichbages
	;Text 600,432,ichleben

Flip 0
WaitTimer fps
Until KeyHit(1)
ichbaalt=ichba
ichbages=ichbages+ichbagestmp
BeendeLevel
SpielEnde(0)
End

;HAUPT;


;ICH;

Function UpdHaupt()
	mx=MouseX()
	my=MouseY()
	mh1=MouseHit(1)
	md1=MouseDown(1)
	
	
	UpdSchalter
	UpdHindernis
	
	UpdTeil
	UpdIch
	UpdTurm
	UpdBatterie
	
	UpdRakete
	
	UpdLicht
End Function

Function UpdIch()
	Local ex#,ey#,dist#,win#
		
	If mh1 And ichpickm=0 And Sqr(ichsx*ichsx+ichsy*ichsy)=<0.01
		ichpicke=CameraPick(ichkam,mx,my)
		If ichpicke=ichobj
			ichpickm=1
		EndIf	
	ElseIf mh1 And ichpickm=1 And ichpicke=ichobj
		If CameraPick(ichkam,mx,my)<>ichpicke
			CameraProject ichkam,EntityX(ichpicke),EntityY(ichpicke),EntityZ(ichpicke)
			
			ex#=ProjectedX()
			ey#=ProjectedY()			
			dist#=Sqr((mx-ex)*(mx-ex)+(my-ey)*(my-ey))/100
			win#=(ATan2(mx-ex,my-ey)+450)Mod 360
				
			ichsx=ichsx-Cos(win)*dist
			ichsy=ichsy+Sin(win)*dist
			
			ichpickm=0
		EndIf
	EndIf
		
	;If mh1 And ichpickm=0
	;	ichpicke=CameraPick(ichkam,mx,my)
	;	If ichpicke<>0
	;		If Left(EntityName(ichpicke),2)="RA"
	;			ichpickm=1
	;		EndIf
	;	EndIf
	;ElseIf mh1 And ichpickm=1
	;	If Left(EntityName(ichpicke),2)="RA"
	;		If CameraPick(ichkam,mx,my)<>ichpicke
	;			CameraProject ichkam,EntityX(ichpicke),EntityY(ichpicke),EntityZ(ichpicke)
	;			
	;			ex#=ProjectedX()
	;			ey#=ProjectedY()			
	;			dist#=Sqr((mx-ex)*(mx-ex)+(my-ey)*(my-ey))/1000
	;			win#=(ATan2(mx-ex,my-ey)+270)Mod 360
	;			
	;			ra=Object.rakete(Mid(EntityName(ichpicke),3,-1))
	;				ra\sx=ra\sx+Cos(win)*dist
	;				ra\sy=ra\sy+Sin(win)*dist
	;				
	;				ra\koll=1
	;					
	;			ichpickm=0
	;		EndIf
	;	EndIf
	;EndIf
	
	ichgesneu=(80-ichleben)/10
	If ichgesneu=8 Then ichgesneu=7
	
	If ichgesalt<>ichgesneu And ichleben>0
		ichgesalt=ichgesneu
		smiley$=ichges[ichgesalt]
		hr=0
		hg=0
		hb=0
		vr=0
		vg=0
		vb=0
		
		Select ichgesalt
			Case 0
				hr=0
				hg=127
				hb=0
				vr=128
				vg=255
				vb=128
			Case 1
				hr=63
				hg=127
				hb=0
				vr=192
				vg=255
				vb=128
			Case 2
				hr=127
				hg=127
				hb=0
				vr=255
				vg=255
				vb=128
			Case 3
				hr=127
				hg=63
				hb=0
				vr=255
				vg=192
				vb=128
			Case 4
				hr=127
				hg=31
				hb=0
				vr=255
				vg=160
				vb=128
			Case 5
				hr=127
				hg=0
				hb=0
				vr=255
				vg=128
				vb=128
			Case 6
				hr=63
				hg=0
				hb=127
				vr=192
				vg=128
				vb=255
			Case 7
				hr=0
				hg=0
				hb=127
				vr=128
				vg=128
				vb=255
		End Select
		
		NeuSmileyTex(ichtex0,smiley,hr,hg,hb,vr,vg,vb,0)
		NeuSmileyTex(ichtex1,smiley,hr,hg,hb,vr,vg,vb,1)
	EndIf
	
	If ichleben=<0;Levelbeenden und Neu
		ichleben=80
		ichba=ichbaalt
		BeendeLevel()
		LadeLevel(leveljetzt$)
	EndIf
End Function

Function UpdIchObj()
	ichsy=ichsy-ichm*GRAV	
	ichsy=ichsy*WIDER
	ichsx=ichsx*WIDER
	
	If EntityCollided(ichobj,2); And Sqr(ichsx*ichsx+ichsy*ichsy)=>ichm*ichw
		sk#=-(ichsx*CollisionNX(ichobj,1)+ichsy*CollisionNY(ichobj,1))
		ichsx=ichsx+2*sk*CollisionNX(ichobj,1)
		ichsy=ichsy+2*sk*CollisionNY(ichobj,1)
		
		ichsx=ichsx*ichw
		ichsy=ichsy*ichw
		
		If ichsy=<0.015 Then ichsy=0
	EndIf
		
	If Abs(ichsx)=<0.001 Then ichsx=0
End Function

;ICH;

;SPIEL;

Function SpielEnde(ende=0)
	LadeLevel("levelend"+ende+".lvl")
	
	EntityParent ichkam,0
	
	;RotateEntity ichkam,0,0,0
	PositionEntity ichkam,1,0,-2
	
	EntityType ichobj,0	
	PositionEntity ichobj,-0.3,-0.5,0.3
	RotateEntity ichobj,0,45,0
	
	If ende=1
		NeuSmileyTex(ichtex0,">:D",0,127,0,128,255,128,0)
		NeuSmileyTex(ichtex1,">:D",0,127,0,128,255,128,1)
	Else
		NeuSmileyTex(ichtex0,":(",0,0,127,128,128,255,0)
		NeuSmileyTex(ichtex1,":(",0,0,127,128,128,255,1)
	EndIf
	
	
	end_blende=LoadTexture("smiley/streifen.png",1)
		ScaleTexture end_blende,0.125,0.25
	
	
	Local textmesh=CreateMesh(),texttex[1],textimg[1]
	texttex[0]=CreateTexture(1024,512)
	texttex[1]=CreateTexture(128,64)
	textimg[0]=CreateImage(1024,512)
	textimg[1]=CreateImage(1024,512)
		surf=CreateSurface(textmesh)
			v0=AddVertex(surf,-1,1,0,0,0)
			v1=AddVertex(surf,1,1,0,0.625,0)
			v2=AddVertex(surf,1,-1,0,0.625,0.9375)
			v3=AddVertex(surf,-1,-1,0,0,0.9375)
			
			AddTriangle(surf,v0,v1,v2)
			AddTriangle(surf,v0,v2,v3)
	
	Local dunkelmesh=CopyEntity(textmesh)	
	
		PositionEntity textmesh,1,0,-1.01
		EntityFX textmesh,1+4
		EntityBlend textmesh,3
		
			SetBuffer ImageBuffer(textimg[0])
				If ende=1
					Color 255,128,64
				Else
					Color 64,64,255
				EndIf
				
				SetFont schriftgr
				x0=(640-StringWidth("SPIELENDE"))/2
				If ende=1 Then x1=(640-StringWidth("ZEIT FR KUCHEN!"))/2
				x2=(640-StringWidth("BATTERIEN:"))/2
				x3=(640-StringWidth(ichba+" von "+ichbages))/2
				
				SetFont schriftgr				
				Text x0,64,"SPIELENDE"
				If ende=1 Then Text x1,128,"ZEIT FR KUCHEN!"				
				Text x2,256,"BATTERIEN:"
				Text x3,320,ichba+" von "+ichbages
				
				SetFont schriftmt
				Text 0,464,"Ballschnipser(c)Fredko (Fredkostudio) 2010 fr den BCC #36 im Blitzforum"
				
			SetBuffer BackBuffer()
		
		CopyRect 0,0,1024,512,0,0,ImageBuffer(textimg[0]),ImageBuffer(textimg[1])
		ScaleImage textimg[1],0.125,0.125
		
		CopyRect 0,0,1024,512,0,0,ImageBuffer(textimg[0]),TextureBuffer(texttex[0])
		CopyRect 0,0,128,64,0,0,ImageBuffer(textimg[1]),TextureBuffer(texttex[1])
		
		
		
		EntityTexture textmesh,texttex[0],0,0
		EntityTexture textmesh,texttex[1],0,1
			TextureBlend texttex[1],3
		EntityTexture textmesh,end_blende,0,2
		
		PositionEntity dunkelmesh,1,0,-1
		EntityColor dunkelmesh,128,128,128
		EntityFX dunkelmesh,1+4
		EntityBlend dunkelmesh,2
	
	Repeat	
	Cls
	
	UpdLicht
	
	UpdateWorld
	RenderWorld
	
	
	Flip
	Until KeyHit(1)
	End
End Function

;SPIEL;