;GEGNER - gegner.bb;

;Gegner, Raketen Type und Funktionen

;GEGNER - gegner.bb;

Type turm
	Field id,modus
	Field mesh
	Field x#,y#,z#
	Field zeit;Nachladezeit
End Type

Global tu.turm


Type rakete
	Field id
	Field mesh
	Field x#,y#,z#
	Field sx#,sy#;Geschwindigkeit
	Field koll,kzeit;Kollidiert, Kollisionszeit (->Explosionstrigger)
End Type

Global ra.rakete


Global turmobj=LoadMesh("3d/turm.3ds")
	EntityRadius turmobj,0.1,0.2
	HideEntity turmobj

Global raketeobj=LoadMesh("3d/rakete.3ds")
	EntityPickMode raketeobj,1
	EntityRadius raketeobj,0.1,0.2
	HideEntity raketeobj


Function NeuTurm(x#,y#,z#)
	tu=New turm
		tu\id=Handle(tu)
		tu\mesh=CopyEntity(turmobj)
		
		tu\x=x
		tu\y=y
		tu\z=z

		PositionEntity tu\mesh,tu\x,tu\y,tu\z
			EntityType tu\mesh,3
		
		tu\zeit=MilliSecs()+2500
End Function


Function UpdTurm()
	For tu=Each turm
		If EntityX(tu\mesh)<>tu\x Or EntityY(tu\mesh)<>tu\y Or EntityZ(tu\mesh)<>tu\z
				EntityType tu\mesh,0
			PositionEntity tu\mesh,tu\x,tu\y,tu\z
				EntityType tu\mesh,3
		EndIf
		
		If EntityDistance(ichobj,tu\mesh)=<5;Zielen
			win#=(ATan2(EntityX(ichobj)-tu\x,tu\y-EntityY(ichobj))+270)Mod 360
			
			RotateEntity tu\mesh,0,0,win-90
			If tu\zeit=<MilliSecs();Schieen
				tu\zeit=MilliSecs()+2500
				
				NeuRakete(tu\id)
			EndIf
		EndIf
	Next
End Function


Function NeuRakete(tuid)
	tu=Object.turm(tuid)
	
	ra=New rakete
		ra\id=Handle(ra)
		ra\mesh=CopyEntity(raketeobj,tu\mesh)
			NameEntity ra\mesh,"RA"+ra\id
			PositionEntity ra\mesh,0,0.6,0
			EntityParent ra\mesh,0
			EntityType ra\mesh,3
			
			win=(EntityRoll(ra\mesh)+450)Mod 360
			ra\sx=Cos(win)*0.05
			ra\sy=Sin(win)*0.05
End Function


Function UpdRakete()
	For ra=Each rakete
		ra\sx=ra\sx*WIDER
		ra\sy=(ra\sy-GRAV*0.001)*WIDER
		
		TranslateEntity ra\mesh,ra\sx,ra\sy,0
		
		UpdateWorld
		
		If EntityCollided(ra\mesh,1) Or EntityCollided(ra\mesh,2) Or EntityCollided(ra\mesh,3)
			ra\koll=1
		EndIf
		
		If ra\koll
			EntityFX ra\mesh,1
			EntityColor ra\mesh,0,255,0
		EndIf
	Next
End Function

;GEGNER - gegner.bb;