;LICHT - licht.bb;

;Licht Einstellungen,Licht Type und Funktionen

AmbientLight 4,4,8

Global licht=CreateLight()
RotateEntity licht,45,0,0
LightColor licht,64,64,64

;LICHT - licht.bb;

Type licht
	Field id,art,modus	;Kugel 1/Kegel 0? An 1/Aus 0?
	Field mesh 			;Mesh
	Field r,g,b,a#		;RGBA
	Field x#,y#,z#		;XYZ
	Field sx#,sy#		;Gre X/Y
End Type

Global li.licht


Global lichtex[1]
lichtex[0]=LoadTexture("gfx/lichtkegel.png",1)
lichtex[1]=LoadTexture("gfx/lichtkugel.png",1)
Global lichtstaub=LoadTexture("gfx/lichtstaub.png",1)
	TextureBlend lichtstaub,3
Global lichtstaubu#,lichtstaubv#

Function NeuLicht(x#,y#,z#,art,r,g,b,a#,sx#=1.0,sy#=1.0)
	li=New licht
		li\id=Handle(li)
		li\art=art
		li\modus=1
		li\mesh=CreateMesh()
			;SURFACE;
			
			surf=CreateSurface(li\mesh)
			
			li\r=r
			li\g=g
			li\b=b
			li\a=a
			
			r=r*a
			g=g*a
			b=b*a
			
			v0=AddVertex(surf,-1,1,0,0,0)	:VertexColor(surf,v0,r,g,b)
			v1=AddVertex(surf,1,1,0,1,0)	:VertexColor(surf,v1,r,g,b)
			v2=AddVertex(surf,1,-1,0,1,1)	:VertexColor(surf,v2,r,g,b)
			v3=AddVertex(surf,-1,-1,0,0,1)	:VertexColor(surf,v3,r,g,b)
			
			AddTriangle(surf,v0,v1,v2)
			AddTriangle(surf,v0,v2,v3)
			
			If li\art=0;KEGEL;
				PositionMesh li\mesh,0,-1,0
			EndIf
			
			;SURFACE;
			
			;ENTITY;
			
			NameEntity li\mesh,li\id
			
			PositionEntity li\mesh,x,y,z
			
			If li\art=0;KEGEL;
				li\sx=sx
				li\sy=sy
				ScaleEntity li\mesh,sx,sy,1
			ElseIf li\art=1;KUGEL;
				li\sx=sx
				li\sy=sx
				ScaleEntity li\mesh,sx,sx,1
			EndIf
			
			EntityBlend li\mesh,3
			EntityFX li\mesh,1+2+4
			
			EntityTexture li\mesh,lichtex[li\art],0,0
			EntityTexture li\mesh,lichtstaub,0,0
			EntityTexture li\mesh,lichtex[li\art],0,2

			;ENTITY
		Return li\mesh
End Function

Function UpdLicht()
	lichtstaubu=lichtstaubu+0.001
	lichtstaubv=lichtstaubv+0.001
	PositionTexture lichtstaub,lichtstaubu,lichtstaubv
End Function

Function KeinLicht()
	For li=Each licht
		FreeEntity li\mesh
		Delete li
	Next
End Function

;LICHT - licht.bb;