;SMILEY - smiley.bb;

;Funktionen zum erzeugen von Smileygesichtern

;SMILEY - smiley.bb;

Global sm_blende=LoadTexture("smiley/blende.png",1)
Global sm_streifen=LoadTexture("smiley/streifen.png",1)

Function NeuSmiley(mesh,stex$,smiley$,hr,hg,hb,vr,vg,vb,mtex=0,tex0=0,tex1=0)
	surfc=CountSurfaces(mesh)
	For i=1 To surfc
		surf=GetSurface(mesh,i)
		brush=GetSurfaceBrush(surf)
		ftex=GetBrushTexture(brush)
		
		If Right(TextureName(ftex),Len(stex))=stex
			;Smiley Gesicht;
			
			Local tex[1]
			
			If mtex=1
				tex[0]=tex0
				tex[1]=tex1
			EndIf
			
			For i=0 To 1
				m=1+7*i
				
				If mtex=0				
					tex[i]=CreateTexture(8*m,8*m)
				EndIf
				
				NeuSmileyTex(tex[i],smiley,hr,hg,hb,vr,vg,vb,i)
			Next
			
			BrushTexture brush,tex[1],0,0
				TextureFilter tex[1],16+32
			BrushTexture brush,tex[0],0,1
				TextureFilter tex[0],16+32
				TextureBlend tex[0],3
			BrushTexture brush,sm_blende,0,2
			BrushTexture brush,sm_streifen,0,3
			
			BrushFX brush,1
			
			PaintSurface surf,brush
			
			;Smiley Gesicht;
		EndIf
	Next
End Function

Function NeuSmileyTex(tex,smiley$,hr,hg,hb,vr,vg,vb,i)
	m=1+7*i
	
		SetBuffer TextureBuffer(tex)
		
		Color 0,0,0
		
		If i=1
			Color hr,hg,hb
		EndIf
		
		Rect 0,0,8*m,8*m
		
		Color vr,vg,vb
					
		;Augenbraue
			Select Left(smiley,1)
				Case ">"
					Rect 1*m,0*m,2*m,1*m
					Rect 3*m,1*m,2*m,1*m
					Rect 5*m,0*m,2*m,1*m
				Case "|"
					Rect 1*m,1*m,6*m,1*m
			End Select
		;Augen
			Rect 2*m,2*m,1*m,2*m
			Rect 5*m,2*m,1*m,2*m
		;Mund
			Select Right(smiley,1)
				Case "D"
					Rect 1*m,5*m,6*m,2*m
					Rect 2*m,7*m,4*m,1*m
				Case ")"
					Rect 2*m,6*m,4*m,1*m
					Rect 1*m,5*m,1*m,1*m
					Rect 6*m,5*m,1*m,1*m
				Case "|"
					Rect 2*m,6*m,4*m,1*m
				Case "("
					Rect 2*m,6*m,4*m,1*m
					Rect 1*m,7*m,1*m,1*m
					Rect 6*m,7*m,1*m,1*m
			End Select
			
		SetBuffer BackBuffer()
End Function

;SMILEY - smiley.bb;