Import "LittleCLasses.bmx"
Import "GUI.bmx"
Import "Maths.bmx"
Import "Images.bmx"

Function SaveLevel()
	Local c:Int
	Local w:String
	Local word:String
	Local DateiName:String = "Level/Level"
	FlushKeys
	Repeat
		Cls
		 c = GetChar()
		If ((c >= 48) And (c <= 57)) Then
		 	w = Chr(c)
		 	word = word + w
		EndIf
		 DrawText(word, 100, 100)
		 Flip
	Until KeyHit(KEY_ENTER)
	
	Local sNew:String = "New"
	DateiName = DateiName + word + ".dat"
	FlushKeys
	Repeat
		Cls
		DrawText(Dateiname, 300, 300)
		Flip
	Until KeyHit(KEY_ENTER)
	

	Local Datei:TStream = WriteStream(Dateiname)
	For Local Brick:TBrick = EachIn TBrick.AllBricks
		WriteInt Datei, sNew.Length
		WriteString Datei, sNew
		WriteInt Datei, Brick.iX
		WriteInt Datei, Brick.iY
		WriteInt Datei, Brick.ired
		WriteInt Datei, brick.igreen
		WriteInt Datei, Brick.iblue
		WriteInt Datei, Brick.sFraction.Length
		WriteString Datei, Brick.sFraction
	Next
		
End Function

Function LoadLevel(pLevel:Int)
	Local c:Int
	Local w:String
	Local word:String
	Local DateiName:String = "Level/Level"
	FlushKeys
	If pLevel = 0 Then
		Repeat
			Cls
		 	c = GetChar()
		 	If ((c >= 48) And (c <= 57)) Then
		 		w = Chr(c)
		 		word = word + w
			EndIf
		 	DrawText(word, 100, 100)
		 	Flip
		Until KeyHit(KEY_ENTER)
	
		DateiName = DateiName + word + ".dat"
		FlushKeys
		Repeat
			Cls
			DrawText(DateiName, 300, 300)
			Flip
		Until KeyHit(KEY_ENTER)
		
	Else
		DateiName = DateiName + pLevel + ".dat"
	EndIf
	Local Datei:TStream = ReadStream(Dateiname)
	If Datei <> Null Then
		While Not Eof(Datei)
			Local iStringLength:Int = ReadInt(Datei)
			Local sTmpString:String = ReadString(Datei, iStringlength)
			Local iTmpX:Int = ReadInt(Datei)
			Local iTmpY:Int = ReadInt(Datei)
			Local iTmpRed:Int = ReadInt(Datei)
			Local iTmpGreen:Int = ReadInt(Datei)
			Local iTmpBlue:Int = ReadInt(Datei)
			Local itmplength:Int = ReadInt(Datei)
			Local stmpFraction:String = ReadString(Datei, itmplength)
			If sTmpString = "New" Then
				Local Brick:TBrick = TBrick.Create(itmpx, itmpy, itmpred, itmpgreen, itmpblue, tiBrick, stmpFraction)
			End If
		Wend
	EndIf
		
End Function