
'Grafik initialisieren
'
	SetGraphicsDriver D3D9Max2DDriver()

'Grafik Hhe und Breite
	Local graphx = 1280
	Local graphy = 800


	Graphics graphx, graphy, 0
	
	SetBlend ALPHABLEND

'Include-Dateien
	Include "TGame.bmx"
	Include "TLevel.bmx"
	Include "TPlayer.bmx"
	Include "TPhysics.bmx"
	Include "TCheckpoint.bmx"
	Include "TTarget.bmx"
	Include "THitObject.bmx"
	Include "TEditPanel.bmx"
	Include "TMenue.bmx"
	Include "TMenueItem.bmx"
	Include "TDynamicObject.bmx"
	Include "TParticleEmitter.bmx"
	Include "TParticle.bmx"
	Include "TColor.bmx"
	Include "TEditor.bmx"
	Include "TMode.bmx"
	Include "TComponent.bmx"
	Include "TDrag.bmx"
	Include "TArea.bmx"
	Include "TScroll.bmx"


'Maus-Variablen
	Global MD:Int
	Global MH:Int
	Global MX:Int
	Global MY:Int
	Global ESC:Int
	
	
'Levels
	Local Temp:String[] = LoadDir( "Maps\", True )
	Global Levels = Temp.length
	Global Finished:Int[ Levels ]
	

	TCheckpoint.General( LoadImage( "GfxNew\checkp.png" ), LoadImage( "GfxNew\checkp_over.png" ), 17 )
	TTarget.General( LoadImage( "GfxNew\tar.png" ), LoadImage( "GfxNew\tar_over.png" ), 17 )
'States
	'State = 0
	Local Player:TPlayer = TPlayer.Init( 20, 20, 13, LoadImage( "GfxNew\testball.png" ), Null) 'LoadImage( "Gfx\gummishadow.png" ) )
	Local Level:TLevel = TLevel.Init( 3000, 500, LoadImage( "GfxNew\test.png" ), LoadAnimImage( "GfxNew\hardline.png", 1, 2500, 0, 100 ), 99 )
	Local Physics:TPhysics = TPhysics.Init( 0, 0, Player )
	
	
	Local PlayComponent:TComponent = TComponent.Init( 20, 20, 1, LoadImage( "GfxNew\play.png" ), 1, 1, LoadImage( "GfxNew\play_over.png" ), 60 )
	Local StopComponent:TComponent = TComponent.Init( 60, 20, 2, LoadImage( "GfxNew\stop.png"), 1, 1, LoadImage( "GfxNew\stop_over.png" ), 60 )
	Local RadiusLine:TComponent = TComponent.Init( 100, 10, 3, LoadImage( "GfxNew\radiusline.png" ) )
	Local RadiusArrow:TComponent = TComponent.Init( 100, 10, 4, LoadImage( "GfxNew\arrow.png" ) )
	Local CirclePencil:TComponent = TComponent.Init( 200, 10, 5, LoadImage( "GfxNew\radius.png" ), 1, 1, LoadImage( "GfxNew\radius_over.png" ) )
	Local LinePencil:TComponent = TComponent.Init( 240, 10, 6, LoadImage( "GfxNew\line.png" ), 1, 1, LoadImage( "GfxNew\line_over.png" ) )
	Local Editable:TComponent = TComponent.Init( 20, 50, 7, LoadImage( "GfxNew\editable.png" ), 1, 1, LoadImage( "GfxNew\editable_over.png" ) )
	Local Hard:TComponent = TComponent.Init( 60, 50, 8, LoadImage( "GfxNew\hard.png" ), 1, 1, LoadImage( "GfxNew\hard_over.png" ) )
	Local Target:TComponent = TComponent.Init( 100, 50, 9, LoadImage( "GfxNew\target.png" ), 1, 1, LoadImage( "GfxNew\target_over.png" ) )
	Local Checkpoint:TComponent = TComponent.Init( 140, 50, 10, LoadImage( "GfxNew\checkpoint.png" ), 1, 1, LoadImage( "GfxNew\checkpoint_over.png" ) )
	Local PlayerPos:TComponent = TComponent.Init( 180, 50, 11, LoadImage( "GfxNew\player.png" ), 1, 1, LoadImage( "GfxNew\player_over.png" ) )
	Local Speed:TComponent = TComponent.Init( 20, 90, 12, LoadImage( "GfxNew\speed.png" ), 1, 1, LoadImage( "GfxNew\speed_over.png" ) )
	Local SpeedLine:TComponent = TComponent.Init( 70, 100, 13, LoadImage( "GfxNew\speedline.png" ) )
	Local SpeedArrow:TComponent = TComponent.Init( 70, 100, 14, LoadImage( "GfxNew\arrow.png" ) )
	Local Save:TComponent = TComponent.Init( 50, 130, 15, LoadImage( "GfxNew\save.png" ) )
	
	RadiusArrow.Drag = TDrag.Init( 100, 30, 200, 30, TDrag.HARD, RadiusArrow )
	SpeedArrow.Drag = TDrag.Init( 70, 120, 170, 120, TDrag.HARD, SpeedArrow )
	
	Local EditPanel:TEditPanel = TEditPanel.Init( 400, 400, LoadImage( "GfxNew\editorpanel.png" ) )
	EditPanel.AddComponents( [PlayComponent, StopComponent, RadiusLine, RadiusArrow, CirclePencil, LinePencil, Editable, Hard, Target, Checkpoint, PlayerPos, ..
		Speed, SpeedLine, SpeedArrow, Save] )
	EditPanel.AddGroup( [CirclePencil, LinePencil, Editable, Hard, Target, Checkpoint, PlayerPos] )
	EditPanel.Drag = TDrag.Init( 0, 0, graphx, graphy, TDrag.SOFT, EditPanel )
	
	Local Editor:TEditor = TEditor.Init( graphx, graphy, ..
		LoadAnimImage( "Gfx\arrow_left.png", 32, 16, 0, 13 ), ..
		LoadAnimImage( "Gfx\arrow_right.png", 32, 16, 0, 13 ), 13, 35, ..
		Level, Physics, Player, EditPanel )
	
	Editor.SetArea( New TArea )
	
	Local GamePanel:TEditPanel = TEditPanel.Init( 400, 400, LoadImage( "GfxNew\gamepanel.png" ) )
	Local GPlay:TComponent = TComponent.Init( 20, 20, 1, LoadImage( "GfxNew\play.png" ), 1, 1, LoadImage( "GfxNew\play_over.png" ), 60 )
	Local GStop:TComponent = TComponent.Init( 60, 20, 2, LoadImage( "GfxNew\stop.png"), 1, 1, LoadImage( "GfxNew\stop_over.png" ), 60 )
	Local GRadiusLine:TComponent = TComponent.Init( 100, 10, 3, LoadImage( "GfxNew\radiusline.png" ) )
	Local GRadiusArrow:TComponent = TComponent.Init( 100, 10, 4, LoadImage( "GfxNew\arrow.png" ) )
	Local GCirclePencil:TComponent = TComponent.Init( 200, 10, 5, LoadImage( "GfxNew\radius.png" ), 1, 1, LoadImage( "GfxNew\radius_over.png" ) )
	Local GReset:TComponent = TComponent.Init( 240, 10, 6, LoadImage( "GfxNew\reset.png" ), 0, 1, LoadImage( "GfxNew\reset_over.png" ) )
	GRadiusArrow.Drag = TDrag.Init( 100, 30, 200, 30, TDrag.HARD, GRadiusArrow )
	GamePanel.AddComponents( [GPlay, GStop, GRadiusLine, GRadiusArrow, GCirclePencil, GReset] )
	GamePanel.AddGroup( [GCirclePencil] )
	GamePanel.Drag = TDrag.Init( 0, 0, graphx, graphy, TDrag.SOFT, GamePanel )
	
	
	Local Game:TGame = TGame.Init( graphx, graphy, Null, Null, 13, 35, Level, Physics, Player, GamePanel )
	
	
	'Local Game:TGame = New TGame
	'Game.Init( graphx, graphy )

'Timer
	Local timer = CreateTimer(60)


'Menue
	Local part1:TParticleEmitter = TParticleEmitter.Init( graphx/2-350, graphy/2-130, 200, 0, -90, -90, 800, 1000, 1, 1, 4, 4, LoadImage("Gfx\pstar.png"), TColor.Init( 255, 230, 30 ), 100, 1 )
	Local part2:TParticleEmitter = TParticleEmitter.Init( graphx/2-250, graphy/2-30, 200, 0, -90, -90, 800, 1000, 1, 1, 4, 4, LoadImage("Gfx\pstar.png"), TColor.Init( 255, 235, 70 ), 100, 1 )
	Local part3:TParticleEmitter = TParticleEmitter.Init( graphx/2-190, graphy/2+70, 270, 0, -90, -90, 800, 1000, 1, 1, 4, 4, LoadImage("Gfx\pstar.png"), TColor.Init( 255, 240, 100 ), 100, 1 )
	Local part4:TParticleEmitter = TParticleEmitter.Init( graphx/2-30, graphy/2+170, 240, 0, -90, -90, 800, 1000, 1, 1, 4, 4, LoadImage("Gfx\pstar.png"), TColor.Init( 255, 240, 125 ), 100, 1 )
	Local part5:TParticleEmitter = TParticleEmitter.Init( graphx/2+60, graphy/2+270, 280, 0, -90, -90, 800, 1000, 1, 1, 4, 4, LoadImage("Gfx\pstar.png"), TColor.Init( 255, 245, 150 ), 100, 1 )
	
	Local menue:TMenue = TMenue.Init( [ TMenueItem.Init( graphx/2-400, graphy/2-200, LoadImage("Gfx\game.png" ), Null, part1 ), ..
		TMenueItem.Init( graphx/2-300, graphy/2-100, LoadImage("Gfx\editor.png" ), Null, part2 ), ..
		TMenueItem.Init( graphx/2-200, graphy/2-0, LoadImage("Gfx\credits.png" ), Null, part3 ), ..
		TMenueItem.Init( graphx/2-50, graphy/2+100, LoadImage("Gfx\settings.png" ), Null, part4 ), ..
		TMenueItem.Init( graphx/2+70, graphy/2+200, LoadImage("Gfx\exit.png" ), Null, part5 ) ] )
	
	TMenueItem.inextID = 1
	
	Local levelmenue:TMenue
	Local levelent:TMenueItem[20]
	Local levelpart:TParticleEmitter.Init( X+75, Y+50, 0, 0, -180, 0, 1000, 1200, 1, 1, 4, 4, LoadImage( "Gfx\pstar.TParticleEmitterg" ), TColor.Init( 100+(I*3), 0, 0 ), 100, 1 )
		levelent[I] = TMenueItem.Init( X, Y, LoadImage( "GfxNew\level.png" ), Null, levelpart[I] )
		X :+ 150
		If X+150 > graphx Then
			X = 10
			Y :+ 100
		EndIf
	Next
	levelmenue = TMenue.Init( levelent )

SetClsColor 255,255,255
Local back:TImage = LoadImage( "GfxNew\back.png" )

Local FPS_FPT:Double
Local FPS_FPS:Double
Local FPS_FPC:Double
Local FPS_MS:Double
Local FPS_OldMS:Double
Local FPS_SpeedFact:Double
'
'HAUPTSCHLEIFE
'
Repeat
	
	Cls
	
	MD = MouseDown(1)
	MH = MouseHit(1)
	MX = MouseX()
	MY = MouseY()
	ESC = KeyHit( KEY_ESCAPE )
	
	TileImage back, 0, 0
	
	'If Game.State = 1 Then Game.Edit()
	'If Game.State = 2 Then Game.Run()
	If State = 0 Or State = 3 Or State = 4 Then
		State = menue.Update( MX, MY, MH )
		MH = 0
	EndIf
	If State = 2 Then
		Editor.Update()
		If ESC Then State = 0
		ESC = 0
	EndIf
	If State = 1 Then
		LevelSelect = levelmenue.Update( MX, MY, MH )
		If ESC Then State = 0
		If LevelSelect > 0 Then
			Game.LoadLevel( "Maps\"+LevelSelect+".z99" )
			State = -1
		EndIf
		ESC = 0
	EndIf
	
	If LevelSelect > 0 Then
		State = Game.Update()
		If State = 1 Then
			Finished[LevelSelect-1] = 1
			levelpart[LevelSelect-1].Color.R = 0
			levelpart[LevelSelect-1].Color.G = 100+((LevelSelect-1)*3)
		EndIf
		If State = 0 Then
			State = 1
			LevelSelect = 0
		EndIf
	EndIf
	
	If FPS_FPT<MilliSecs() Then
		FPS_FPS = FPS_FPC
		FPS_FPC = 0
		FPS_FPT = MilliSecs()+1000
	EndIf
	FPS_FPC:+1
	FPS_MS = MilliSecs()-FPS_OldMS
	FPS_OldMS = MilliSecs()
	FPS_SpeedFact = Double(FPS_MS)/(1000/60)
	
	DrawText FPS_FPS, 20, 20

	Flip 0
	
	
	WaitTimer( timer )
	
Until (ESC And State = 0) Or AppTerminate() Or State = 5



Function MouseOver( X, Y, W, H )
	
	If MX > X And MX < X+W And MY > Y And MY < Y+H Then Return 1
	Return 0
	
EndFunction



Function SaveGame( Path:String )
	
	Local File:TStream
	
	File = WriteFile ( Path )
	If Not File Then Return
	
	WriteInt File, Levels
	For I = 0 To Levels-1
		WriteInt File, Finished[I]
	Next
	
	
	CloseFile( File )
	
End Function





